﻿
Imports System.IO

Public Class frmBookmark
    Dim Proc As String = "Explorer.exe"
    Dim pro As New Process, pr() As Process

    Dim fCont, folderName, fileName, ffName As String
    Dim sp(), t, seli, curText As String
    Dim i As Short
    Dim aField() As String = {"/min="}  'Startparameter für minimierten Start des Programms
    Dim cl As String, mW As Boolean = False, proFlag As Boolean = False
    Dim max, j As Long
    Dim strgFlag, sortFlag As Boolean

    Dim toolTipFont As New Font("Microsoft Sans Serif", 14)
    Dim re As Rectangle, sizeK, k As Short
    Dim cursorSize As Size, cursorPos As Point
    Dim myPoint As Point, myIndex As Short
    Dim img As Bitmap = My.Resources.Folder_blue_favs_32
    Dim tabs As Single() = {10} 'Tabulator für ToolTip

    '<DllImport("user32.dll")>
    Function MoveWindow(hWnd As IntPtr, x As Integer, y As Integer,
        nWidth As Integer, nHeight As Integer, bRepaint As Boolean) As Boolean
    End Function

    Public Sub New()
        MyBase.New()
        InitializeComponent()
        SetDefaultControlStyles()
    End Sub
    Private Sub SetDefaultControlStyles()
        With Me
            .SetStyle(ControlStyles.DoubleBuffer, True)
            .SetStyle(ControlStyles.AllPaintingInWmPaint, False)
            .SetStyle(ControlStyles.ResizeRedraw, True)
            .SetStyle(ControlStyles.UserPaint, True)
        End With
    End Sub

    Private Sub frmBookmark_Load(sender As Object, e As EventArgs) _
        Handles MyBase.Load
        instRunBM()

        folderName = GetSetting("ExplorerBookmarks", "Variable", "Ordner")
        fileName = GetSetting("ExplorerBookmarks", "Variable", "File")
        ffName = folderName + fileName

        'Startparameter einstellen
        'hier nur eventuell /min=True oder False
        Dim clFeld() As String = ParseCommandLineArgsBM(aField)
        If clFeld.Length >= 1 Then
            cl = Split(clFeld(0), "=")(1)
            mW = CBool(cl)
        End If

        pro.StartInfo.FileName = Proc
        pro.StartInfo.UserName = "VBasic"

        '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        fCont = GetFileContentsBM(ffName)   'lesen des Lesezeichen-Files
        sp = Split(fCont, vbCrLf)
        lstBookmarks.Items.AddRange(sp)     'füllen der Listbox mit Lesezeichen
        staAnz.Text = "Anzahl: " & lstBookmarks.Items.Count
        sortFlag = False
        btnSort.Image = My.Resources.sort_descending
        CornerForm(Me, PositionsOfObjects.BottomCenterBorder, scrNr)    '###
    End Sub

    Private Sub FrmBookmark_Shown(sender As Object, e As EventArgs) _
        Handles Me.Shown
        If mW Then WindowState = FormWindowState.Minimized
    End Sub

    Private Sub frmBookmark_FormClosing(sender As Object, e As FormClosingEventArgs) _
        Handles Me.FormClosing
        'speichern der Variablen
        SaveSetting("ExplorerBookmarks", "Variable", "Ordner", folderName)
        SaveSetting("ExplorerBookmarks", "Variable", "File", fileName)
        If Not proFlag Then Exit Sub
        ' den aktuellen Explorer ermitteln und schließen
        pr = Process.GetProcessesByName("explorer")
        If pr.Length > 0 Then
            For i = 0 To pr.Length - 1
                If max < pr(i).StartTime.Ticks Then
                    max = pr(i).StartTime.Ticks
                    j = i
                End If
            Next
            pr(j).Kill()
            pr(j).WaitForExit()
        End If
    End Sub

    Private Sub BtnBookmark_Click(sender As Object, e As EventArgs) _
        Handles btnBookmark.Click
        'einlesen des Clipboard-Inhalts
        If lstBookmarks.SelectedItems.Count > 0 Then lstBookmarks.ClearSelected()
        Dim tt(0) As String
        Dim ido As IDataObject = Clipboard.GetDataObject()
        If ido.GetDataPresent(DataFormats.FileDrop) Then
            tt = CType(ido.GetData(DataFormats.FileDrop), String())
            If Path.GetExtension(tt(0)) = "" Then tt(0) &= "\"
        Else
            tt(0) = "Es konnten keine Daten aus der Zwischenablage abgerufen werden."
            Exit Sub
        End If
        tt(0) = tt(0).Replace(".", "/")
        lblAnzeige.Text = tt(0).Replace("/", ".")
    End Sub

    Private Sub btnSort_Click(sender As Object, e As EventArgs) _
        Handles btnSort.Click
        'sortieren der Listbox Items, ASC oder DESC
        If sortFlag Then
            lstBookmarks.Sorted = sortFlag
            lstBookmarks.Refresh()
            btnSort.Image = My.Resources.sort_descending
            ToolTip1.SetToolTip(btnSort, "sortieren DESC")
        Else
            sortFlag = False
            DescList()
            btnSort.Image = My.Resources.sort_ascending
            ToolTip1.SetToolTip(btnSort, "sortieren ASC")
        End If
        sortFlag = Not sortFlag
    End Sub

    Private Sub btnAuswahl_Click(sender As Object, e As EventArgs) _
        Handles btnAuswahl.Click
        ' Auswahl des Ordners für Bookmaks-File
        folderName = showFolderBrowserDialogBM(folderName)
        If folderName = "" Then
            folderName = GetSetting("ExplorerBookmarks", "Variable", "Ordner")
        Else
            folderName += "\"
        End If
        ffName = folderName + fileName
        lblFolder.Text = folderName
    End Sub

    Private Sub btnLzFile_Click(sender As Object, e As EventArgs) _
        Handles btnLzFile.Click
        ' Speichern vom Namen des Lesezeichen-Files
        fileName = txtLzFile.Text
        ffName = folderName + fileName
    End Sub

    Private Sub BtnStore_Click(sender As Object, e As EventArgs) _
        Handles btnStore.Click
        'speichern des Lesezeichens in die Listbox
        'und zusätzlich speichern aller Lesezeichen ins Lesezeichen-File
        If lblAnzeige.Text = "leer" Then Exit Sub
        If lstBookmarks.FindString(lblAnzeige.Text) >= 0 Then
            staMsg.Text = "Lesezeichen schon vorhanden!"
        Else
            lstBookmarks.Items.Add(lblAnzeige.Text)
            staAnz.Text = "Anzahl: " & lstBookmarks.Items.Count
            SetFileContentsBM(ffName, Join(setArrayFromListboxBM(lstBookmarks), vbCrLf))  '***
            staMsg.Text = "Lesezeichen gespeichert!"
        End If
    End Sub

    Private Sub BtnDelete_Click(sender As Object, e As EventArgs) _
        Handles btnDelete.Click
        'löschen von selektierten Lesezeichen (Multi-Select möglich)
        Dim ok As DialogResult = MessageBox.Show(
                        "Die gewählten Lesezeichen wirklich löschen?", "FRAGE",
                        MessageBoxButtons.YesNo, MessageBoxIcon.Question)
        If ok = DialogResult.Yes Then
            With lstBookmarks
                For i = 0 To .SelectedItems.Count - 1
                    .Items.RemoveAt(.SelectedIndex)
                Next
                .Refresh()
                staAnz.Text = "Anzahl: " & .Items.Count
            End With
            'speichern aller Lesezeichen ins Lesezeichen-File
            SetFileContentsBM(fileName, Join(setArrayFromListbox(lstBookmarks), vbCrLf))  '***
        Else
            lstBookmarks.ClearSelected()
        End If
    End Sub

    Private Sub BtnDeleteAll_Click(sender As Object, e As EventArgs) _
        Handles btnDeleteAll.Click
        'alle Listbox Items löschen
        With lstBookmarks
            For i = 0 To .Items.Count - 1
                .SelectedItems.Add(.Items.Item(i))
            Next
        End With
        btnDelete.PerformClick()
    End Sub

    Private Sub BtnEnd_Click(sender As Object, e As EventArgs) _
        Handles btnEnd.Click
        'das Programm beenden
        'und zusätzlich speichern aller Lesezeichen ins Lesezeichen-File
        SetFileContentsBM(ffName, Join(setArrayFromListboxBM(lstBookmarks), vbCrLf))  '***
        Application.Exit()
    End Sub

    Private Sub LstBookmarks_SelectedIndexChanged(sender As Object, e As EventArgs) _
        Handles lstBookmarks.SelectedIndexChanged
        staSel.Text = "Selectierte Lesezeichen: " & lstBookmarks.SelectedItems.Count
    End Sub

    Private Sub LstBookmarks_DoubleClick(sender As Object, e As EventArgs) _
        Handles lstBookmarks.DoubleClick
        strgFlag = False
        If ModifierKeys = Keys.Control Then
            ' Wenn die STRG-Taste gedrückt wird, während auf das Lesezeichen doppelt geklickt wird,
            ' wird die über Lesezeichen gewählte Datei geöffnet
            strgFlag = True
            staMsg.Text = "Strg gedrückt."
        End If

        ' gehe zu Bookmark inkl. öffnen des Explorer
        seli = Quote(lstBookmarks.SelectedItem)

        If IsFolder(seli) Then
            pro.Start(Proc, "/e," & seli)   'Folder anzeigen
        Else
            If strgFlag Then
                pro.Start(Proc, "/e," & seli)   'File öffnen
            Else
                pro.Start(Proc, "/e,/select," & seli)   'File anzeigen
            End If
        End If
        proFlag = True
        lstBookmarks.ClearSelected()
    End Sub

    Private Sub LstBookmarks_MouseEnter(sender As Object, e As EventArgs) _
        Handles lstBookmarks.MouseEnter
        tooltipTimer.Start()
    End Sub

    Private Sub LstBookmarks_MouseLeave(sender As Object, e As EventArgs) _
        Handles lstBookmarks.MouseLeave
        tooltipTimer.Stop()
    End Sub

    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ToolTip OwnerDrawn
    Private Sub ToolTip1_Popup(sender As Object, e As PopupEventArgs) _
        Handles ToolTip1.Popup
        ' Tooltip anzeigen
        sizeK = toolTipFont.Size    ' Fontgröße des ToolTips
        k = CShort(sizeK / 3)       ' Abstand des inneren Rechtecks (Text) zum äußeren
        cursorSize = Cursor.Size
        cursorPos = Cursor.Position
        With e
            .ToolTipSize _
                = TextRenderer.MeasureText(ToolTip1.GetToolTip(e.AssociatedControl), toolTipFont)
            .ToolTipSize = New Size(.ToolTipSize.Width + sizeK + img.Width,
                                    .ToolTipSize.Height + sizeK + k)
            re = New Rectangle(k, 0, .ToolTipSize.Width + img.Width, .ToolTipSize.Height)
            re.Inflate(-k - img.Width, -k)
        End With
    End Sub

    Private Sub ToolTip1_Draw(sender As Object, e As DrawToolTipEventArgs) _
        Handles ToolTip1.Draw
        ' ToolTip zeichnen
        Dim sf As New StringFormat(StringFormat.GenericTypographic) _
            With {.LineAlignment = StringAlignment.Center,
            .Alignment = StringAlignment.Near}
        sf.SetTabStops(0, tabs)
        With e
            .Graphics.SmoothingMode = Drawing2D.SmoothingMode.HighQuality
            .DrawBackground()
            .DrawBorder()
            ' Draw Image
            .Graphics.DrawImage(img, k, k)
            ' Draw Text
            .Graphics.DrawString(.ToolTipText, toolTipFont, Brushes.Brown, re, sf)
        End With

        ' positionieren des ToolTips anhand der CursorPosition und -größe
        Dim t = CType(sender, Windows.Forms.ToolTip)
        Dim h = t.[GetType]().GetProperty("Handle",
                Reflection.BindingFlags.NonPublic Or Reflection.BindingFlags.Instance)
        Dim handle = CType(h.GetValue(t), IntPtr)
        Dim location = New Point(cursorPos.X + cursorSize.Width / 2,
                                 cursorPos.Y + cursorSize.Height + k)  ' 5 ist Korrektur
        MoveWindow(handle, location.X, location.Y, e.Bounds.Width, e.Bounds.Height, False)  ' API
    End Sub

    Private Sub TooltipTimer_Tick(sender As Object, e As EventArgs) _
        Handles tooltipTimer.Tick
        With lstBookmarks
            myPoint = .PointToClient(Cursor.Position)
            myIndex = .IndexFromPoint(myPoint)
            If myIndex < 0 Then Exit Sub
            curText = .GetItemText(.Items(myIndex))
            If ToolTip1.GetToolTip(lstBookmarks) <> curText Then
                ToolTip1.SetToolTip(lstBookmarks, curText)
            End If
        End With
    End Sub
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    Sub DescList()
        ' Listbox sortieren in absteigende Folge
        With lstBookmarks
            Dim arr(.Items.Count - 1) As String
            .Items.CopyTo(arr, 0)
            Array.Reverse(arr)
            .Items.Clear()
            .Items.AddRange(arr)
        End With
    End Sub

    Function IsFolder(PathOrFile As String) As Boolean
        Try
            Return My.Computer.FileSystem.DirectoryExists(PathOrFile)
        Catch ex As Exception
            Return False
        End Try
    End Function

End Class
