﻿
Imports System.IO
Imports System.Runtime.InteropServices

Module modBookmarks
    'prüfen, ob schon Instanz läuft
    Public Sub instRunBM()
        If AlreadyRunning() Then
            MessageBox.Show(
                "Eine andere Instanz des Programms läuft schon.", "Already Running",
                MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Application.Exit()
        End If
    End Sub

    ''' <summary>
    ''' Commandline-Argumente lesen und übernehmen
    ''' </summary>
    ''' <param name="argField">Feld der Parameterbezeichnungen /bezeichnung=</param>
    ''' <returns>Feld mit den Werten</returns>
    Public Function ParseCommandLineArgsBM(argField() As String) As String()
        If IsNothing(argField) Then Return Nothing
        Dim clField() As String
        Dim i As Short, anz As Short = Environment.GetCommandLineArgs.Count
        If anz >= 1 Then
            clField = deleteElemOfArrayIdx(Environment.GetCommandLineArgs, 0)
        Else
            clField = Environment.GetCommandLineArgs
        End If
        anz = clField.Length
        Dim cmdFeld(anz - 1) As String  'ja
        i = 0
        For Each s As String In clField
            cmdFeld(i) = s
            i += 1
        Next s
        Return cmdFeld
    End Function

    ''' <summary>
    ''' Inhalt einer Textdatei lesen
    ''' </summary>
    ''' <param name="file_name">Name der Textdatei</param>
    Public Function GetFileContentsBM(file_name As String) As String
        Try
            Dim stream_reader As New StreamReader(file_name, True)
            Dim contents As String = stream_reader.ReadToEnd()
            stream_reader.Close()
            Return contents
        Catch ex As Exception
            Return ""
        End Try
    End Function

    'Text in einer Textdatei speichern
    Public Sub SetFileContentsBM(file_name As String, contents As String)
        Dim StrWr As New StreamWriter(file_name, False)
        StrWr.Write(contents)
        StrWr.Close()
    End Sub

    Public Function showFolderBrowserDialogBM(Optional indd As String = "") As String
        Dim MyDialog As New FolderBrowserDialog()
        With MyDialog
            .SelectedPath = indd
            If (.ShowDialog() = DialogResult.OK) Then
                Return .SelectedPath
            Else
                Return ""
            End If
        End With
    End Function

    Public Function setArrayFromListboxBM(theBox As ListBox) As String()
        Dim temp(theBox.Items.Count - 1) As String, i As Short
        For i = 0 To theBox.Items.Count - 1
            temp(i) = theBox.Items(i)
        Next
        Return temp
    End Function

    '<Extension()>
    Public Function Quote(text As String) As String
        Return SurroundWith(text, """")
    End Function

    '<Extension()>
    Public Function SurroundWith(text As String, surrounds As String) As String
        Return surrounds & text & surrounds
    End Function

End Module
